vsg: vsg::DescriptorPool Class Reference

vsg 1.1.13 VulkanSceneGraph library

Loading...
Searching...
No Matches
vsg::DescriptorPool Class Reference

DescriptorPool encapsulates management of VkDescriptorPool. More...

`#include <DescriptorPool.h>`

Inheritance diagram for vsg::DescriptorPool:
[legend]
Collaboration diagram for vsg::DescriptorPool:
[legend]

## Public Member Functions
| DescriptorPool (Device *device, uint32_t in_maxSets, const DescriptorPoolSizes &in_descriptorPoolSizes)
| operator VkDescriptorPool () const
VkDescriptorPool | vk () const
Device * | getDevice ()
const Device * | getDevice () const
ref_ptr< DescriptorSet::Implementation > | allocateDescriptorSet (DescriptorSetLayout *descriptorSetLayout)
| allocate or reuse available DescriptorSet::Implementation - called automatically when compiling DescriptorSet
void | freeDescriptorSet (ref_ptr< DescriptorSet::Implementation > dsi)
| free DescriptorSet::Implementation for reuse - called automatically by destruction of DescriptorSet or release of its Vulkan resources.
bool | available (uint32_t &numSets, DescriptorPoolSizes &descriptorPoolSizes) const
| get the stats of the available DescriptorSets/Descriptors
bool | used (uint32_t &numSets, DescriptorPoolSizes &usedDescriptorPoolSizes) const
| compute the number of sets and descriptors used.
void | report (std::ostream &out, indentation indent={}) const
| write the internal details to stream.
Public Member Functions inherited from vsg::Inherit< Object, DescriptorPool >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | accept (ConstVisitor &visitor) const
virtual void | traverse (ConstVisitor &) const
virtual void | accept (RecordTraversal &visitor) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
const uint32_t | maxSets = 0
const DescriptorPoolSizes | descriptorPoolSizes
std::mutex | mutex

## Protected Attributes
VkDescriptorPool | _descriptorPool
ref_ptr< Device > | _device
uint32_t | _availableDescriptorSet
DescriptorPoolSizes | _availableDescriptorPoolSizes
std::list< ref_ptr< DescriptorSet::Implementation > > | _recyclingList

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, DescriptorPool >
static ref_ptr< DescriptorPool > | create (Args &&... args)
static ref_ptr< DescriptorPool > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

DescriptorPool encapsulates management of VkDescriptorPool.

## Member Data Documentation

## ◆ mutex

std::mutex vsg::DescriptorPool::mutex
| mutable

mutex used to ensure thread safe access of DescriptorPool resources. Locked automatically by allocateDescriptorSet(..), freeDescriptorSet(), available() and DescriptorSet:::Implementation to ensure thread safe operation. Normal VulkanSceneGraph usage will not require users to lock this mutex so treat as an internal implementation detail.

The documentation for this class was generated from the following file:

- include/vsg/vk/DescriptorPool.h